JUCE: StringRef Class Reference

JUCE

Public Member Functions | Public Attributes | List of all members
StringRef Class Referencefinal
juce_core » text

A simple class for holding temporary references to a string literal or String. More...

`#include <juce_StringRef.h>`

## Public Member Functions
| StringRef (const char *stringLiteral) noexcept
| Creates a StringRef from a raw string literal. More...
| StringRef (String::CharPointerType stringLiteral) noexcept
| Creates a StringRef from a raw char pointer. More...
| StringRef (const String &string) noexcept
| Creates a StringRef from a String. More...
| StringRef (const std::string &string)
| Creates a StringRef from a String. More...
| StringRef () noexcept
| Creates a StringRef pointer to an empty string. More...
| operator const String::CharPointerType::CharType * () const noexcept
| Returns a raw pointer to the underlying string data. More...
| operator String::CharPointerType () const noexcept
| Returns a pointer to the underlying string data as a char pointer object. More...
bool | isEmpty () const noexcept
| Returns true if the string is empty. More...
bool | isNotEmpty () const noexcept
| Returns true if the string is not empty. More...
int | length () const noexcept
| Returns the number of characters in the string. More...
juce_wchar | operator[] (int index) const noexcept
| Retrieves a character by index. More...
bool | operator== (const String &s) const noexcept
| Compares this StringRef with a String. More...
bool | operator!= (const String &s) const noexcept
| Compares this StringRef with a String. More...
bool | operator< (const String &s) const noexcept
| Compares this StringRef with a String. More...
bool | operator<= (const String &s) const noexcept
| Compares this StringRef with a String. More...
bool | operator> (const String &s) const noexcept
| Compares this StringRef with a String. More...
bool | operator>= (const String &s) const noexcept
| Compares this StringRef with a String. More...
bool | operator== (StringRef s) const noexcept
| Case-sensitive comparison of two StringRefs. More...
bool | operator!= (StringRef s) const noexcept
| Case-sensitive comparison of two StringRefs. More...

## Public Attributes
String::CharPointerType | text
| The text that is referenced. More...

## Detailed Description

A simple class for holding temporary references to a string literal or String.

Unlike a real String object, the StringRef does not allocate any memory or take ownership of the strings you give to it - it simply holds a reference to a string that has been allocated elsewhere. The main purpose of the class is to be used instead of a const String& as the type of function arguments where the caller may pass either a string literal or a String object. This means that when the called uses a string literal, there's no need for an temporary String object to be allocated, and this cuts down overheads substantially.

Because the class is simply a wrapper around a pointer, you should always pass it by value, not by reference.

void myStringFunction1 (const String&);
void myStringFunction2 (StringRef);
myStringFunction1 ("abc"); // Implicitly allocates a temporary String object.
myStringFunction2 ("abc"); // Much faster, as no local allocations are needed.
StringRef
A simple class for holding temporary references to a string literal or String.
Definition: juce_StringRef.h:63
String
The JUCE String class!
Definition: juce_String.h:54

For examples of it in use, see the XmlElement or StringArray classes.

Bear in mind that there are still many cases where it's better to use an argument which is a const String&. For example if the function stores the string or needs to internally create a String from the argument, then it's better for the original argument to already be a String.

See also
  String

## Constructor & Destructor Documentation

## ◆ StringRef() [1/5]

StringRef::StringRef | ( | const char * | stringLiteral | ) |
| noexcept

Creates a StringRef from a raw string literal.

The StringRef object does NOT take ownership or copy this data, so you must ensure that the data does not change during the lifetime of the StringRef. Note that this pointer cannot be null!

## ◆ StringRef() [2/5]

StringRef::StringRef | ( | String::CharPointerType | stringLiteral | ) |
| noexcept

Creates a StringRef from a raw char pointer.

The StringRef object does NOT take ownership or copy this data, so you must ensure that the data does not change during the lifetime of the StringRef.

## ◆ StringRef() [3/5]

StringRef::StringRef | ( | const String & | string | ) |
| noexcept

Creates a StringRef from a String.

The StringRef object does NOT take ownership or copy the data from the String, so you must ensure that the String is not modified or deleted during the lifetime of the StringRef.

## ◆ StringRef() [4/5]

StringRef::StringRef | ( | const std::string & | string | ) |

Creates a StringRef from a String.

The StringRef object does NOT take ownership or copy the data from the std::string, so you must ensure that the source string object is not modified or deleted during the lifetime of the StringRef.

## ◆ StringRef() [5/5]

StringRef::StringRef | ( |  | ) |
| noexcept

Creates a StringRef pointer to an empty string.

## Member Function Documentation

## ◆ operator const String::CharPointerType::CharType *()

StringRef::operator const String::CharPointerType::CharType * | ( |  | ) | const
| noexcept

Returns a raw pointer to the underlying string data.

## ◆ operator String::CharPointerType()

StringRef::operator String::CharPointerType | ( |  | ) | const
| noexcept

Returns a pointer to the underlying string data as a char pointer object.

## ◆ isEmpty()

bool StringRef::isEmpty | ( |  | ) | const
| noexcept

Returns true if the string is empty.

## ◆ isNotEmpty()

bool StringRef::isNotEmpty | ( |  | ) | const
| noexcept

Returns true if the string is not empty.

## ◆ length()

int StringRef::length | ( |  | ) | const
| noexcept

Returns the number of characters in the string.

## ◆ operator[]()

juce_wchar StringRef::operator[] | ( | int | index | ) | const
| noexcept

Retrieves a character by index.

## ◆ operator==() [1/2]

bool StringRef::operator== | ( | const String & | s | ) | const
| noexcept

Compares this StringRef with a String.

## ◆ operator!=() [1/2]

bool StringRef::operator!= | ( | const String & | s | ) | const
| noexcept

Compares this StringRef with a String.

## ◆ operator<()

bool StringRef::operator< | ( | const String & | s | ) | const
| noexcept

Compares this StringRef with a String.

## ◆ operator<=()

bool StringRef::operator<= | ( | const String & | s | ) | const
| noexcept

Compares this StringRef with a String.

## ◆ operator>()

bool StringRef::operator> | ( | const String & | s | ) | const
| noexcept

Compares this StringRef with a String.

## ◆ operator>=()

bool StringRef::operator>= | ( | const String & | s | ) | const
| noexcept

Compares this StringRef with a String.

## ◆ operator==() [2/2]

bool StringRef::operator== | ( | StringRef | s | ) | const
| noexcept

Case-sensitive comparison of two StringRefs.

## ◆ operator!=() [2/2]

bool StringRef::operator!= | ( | StringRef | s | ) | const
| noexcept

Case-sensitive comparison of two StringRefs.

## Member Data Documentation

## ◆ text

String::CharPointerType StringRef::text

The text that is referenced.

Referenced by Rectangle< ValueType >::fromString(), and operator+().

The documentation for this class was generated from the following file:

- juce_StringRef.h